// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`GetObjectAcl`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`bucket(impl ::std::convert::Into<String>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::bucket) / [`set_bucket(Option<String>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::set_bucket): <p>The bucket name that contains the object for which to get the ACL information. </p>  <p>When using this action with an access point, you must direct requests to the access point hostname. The access point hostname takes the form <i>AccessPointName</i>-<i>AccountId</i>.s3-accesspoint.<i>Region</i>.amazonaws.com. When using this action with an access point through the Amazon Web Services SDKs, you provide the access point ARN in place of the bucket name. For more information about access point ARNs, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/using-access-points.html">Using access points</a> in the <i>Amazon S3 User Guide</i>.</p>
    ///   - [`key(impl ::std::convert::Into<String>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::key) / [`set_key(Option<String>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::set_key): <p>The key of the object for which to get the ACL information.</p>
    ///   - [`version_id(impl ::std::convert::Into<String>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::version_id) / [`set_version_id(Option<String>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::set_version_id): <p>VersionId used to reference a specific version of the object.</p>
    ///   - [`request_payer(RequestPayer)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::request_payer) / [`set_request_payer(Option<RequestPayer>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::set_request_payer): <p>Confirms that the requester knows that they will be charged for the request. Bucket owners need not specify this parameter in their requests. For information about downloading objects from Requester Pays buckets, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/dev/ObjectsinRequesterPaysBuckets.html">Downloading Objects in Requester Pays Buckets</a> in the <i>Amazon S3 User Guide</i>.</p>
    ///   - [`expected_bucket_owner(impl ::std::convert::Into<String>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::expected_bucket_owner) / [`set_expected_bucket_owner(Option<String>)`](crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::set_expected_bucket_owner): <p>The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code <code>403 Forbidden</code> (access denied).</p>
    /// - On success, responds with [`GetObjectAclOutput`](crate::operation::get_object_acl::GetObjectAclOutput) with field(s):
    ///   - [`owner(Option<Owner>)`](crate::operation::get_object_acl::GetObjectAclOutput::owner): <p> Container for the bucket owner's display name and ID.</p>
    ///   - [`grants(Option<Vec<Grant>>)`](crate::operation::get_object_acl::GetObjectAclOutput::grants): <p>A list of grants.</p>
    ///   - [`request_charged(Option<RequestCharged>)`](crate::operation::get_object_acl::GetObjectAclOutput::request_charged): <p>If present, indicates that the requester was successfully charged for the request.</p>
    /// - On failure, responds with [`SdkError<GetObjectAclError>`](crate::operation::get_object_acl::GetObjectAclError)
    pub fn get_object_acl(
        &self,
    ) -> crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder {
        crate::operation::get_object_acl::builders::GetObjectAclFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
