// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`ListObjectVersions`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`bucket(impl ::std::convert::Into<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::bucket) / [`set_bucket(Option<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::set_bucket): <p>The bucket name that contains the objects. </p>
    ///   - [`delimiter(impl ::std::convert::Into<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::delimiter) / [`set_delimiter(Option<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::set_delimiter): <p>A delimiter is a character that you specify to group keys. All keys that contain the same string between the <code>prefix</code> and the first occurrence of the delimiter are grouped under a single result element in CommonPrefixes. These groups are counted as one result against the max-keys limitation. These keys are not returned elsewhere in the response.</p>
    ///   - [`encoding_type(EncodingType)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::encoding_type) / [`set_encoding_type(Option<EncodingType>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::set_encoding_type): <p>Requests Amazon S3 to encode the object keys in the response and specifies the encoding method to use. An object key may contain any Unicode character; however, XML 1.0 parser cannot parse some characters, such as characters with an ASCII value from 0 to 10. For characters that are not supported in XML 1.0, you can add this parameter to request that Amazon S3 encode the keys in the response.</p>
    ///   - [`key_marker(impl ::std::convert::Into<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::key_marker) / [`set_key_marker(Option<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::set_key_marker): <p>Specifies the key to start with when listing objects in a bucket.</p>
    ///   - [`max_keys(i32)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::max_keys) / [`set_max_keys(Option<i32>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::set_max_keys): <p>Sets the maximum number of keys returned in the response. By default the action returns up to 1,000 key names. The response might contain fewer keys but will never contain more. If additional keys satisfy the search criteria, but were not returned because max-keys was exceeded, the response contains <istruncated>   true  </istruncated>. To return the additional keys, see key-marker and version-id-marker.</p>
    ///   - [`prefix(impl ::std::convert::Into<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::prefix) / [`set_prefix(Option<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::set_prefix): <p>Use this parameter to select only those keys that begin with the specified prefix. You can use prefixes to separate a bucket into different groupings of keys. (You can think of using prefix to make groups in the same way you'd use a folder in a file system.) You can use prefix with delimiter to roll up numerous objects into a single result under CommonPrefixes. </p>
    ///   - [`version_id_marker(impl ::std::convert::Into<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::version_id_marker) / [`set_version_id_marker(Option<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::set_version_id_marker): <p>Specifies the object version you want to start listing from.</p>
    ///   - [`expected_bucket_owner(impl ::std::convert::Into<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::expected_bucket_owner) / [`set_expected_bucket_owner(Option<String>)`](crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::set_expected_bucket_owner): <p>The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code <code>403 Forbidden</code> (access denied).</p>
    /// - On success, responds with [`ListObjectVersionsOutput`](crate::operation::list_object_versions::ListObjectVersionsOutput) with field(s):
    ///   - [`is_truncated(bool)`](crate::operation::list_object_versions::ListObjectVersionsOutput::is_truncated): <p>A flag that indicates whether Amazon S3 returned all of the results that satisfied the search criteria. If your results were truncated, you can make a follow-up paginated request using the NextKeyMarker and NextVersionIdMarker response parameters as a starting place in another request to return the rest of the results.</p>
    ///   - [`key_marker(Option<String>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::key_marker): <p>Marks the last key returned in a truncated response.</p>
    ///   - [`version_id_marker(Option<String>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::version_id_marker): <p>Marks the last version of the key returned in a truncated response.</p>
    ///   - [`next_key_marker(Option<String>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::next_key_marker): <p>When the number of responses exceeds the value of <code>MaxKeys</code>, <code>NextKeyMarker</code> specifies the first key not returned that satisfies the search criteria. Use this value for the key-marker request parameter in a subsequent request.</p>
    ///   - [`next_version_id_marker(Option<String>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::next_version_id_marker): <p>When the number of responses exceeds the value of <code>MaxKeys</code>, <code>NextVersionIdMarker</code> specifies the first object version not returned that satisfies the search criteria. Use this value for the version-id-marker request parameter in a subsequent request.</p>
    ///   - [`versions(Option<Vec<ObjectVersion>>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::versions): <p>Container for version information.</p>
    ///   - [`delete_markers(Option<Vec<DeleteMarkerEntry>>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::delete_markers): <p>Container for an object that is a delete marker.</p>
    ///   - [`name(Option<String>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::name): <p>The bucket name.</p>
    ///   - [`prefix(Option<String>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::prefix): <p>Selects objects that start with the value supplied by this parameter.</p>
    ///   - [`delimiter(Option<String>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::delimiter): <p>The delimiter grouping the included keys. A delimiter is a character that you specify to group keys. All keys that contain the same string between the prefix and the first occurrence of the delimiter are grouped under a single result element in <code>CommonPrefixes</code>. These groups are counted as one result against the max-keys limitation. These keys are not returned elsewhere in the response.</p>
    ///   - [`max_keys(i32)`](crate::operation::list_object_versions::ListObjectVersionsOutput::max_keys): <p>Specifies the maximum number of objects to return.</p>
    ///   - [`common_prefixes(Option<Vec<CommonPrefix>>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::common_prefixes): <p>All of the keys rolled up into a common prefix count as a single return when calculating the number of returns.</p>
    ///   - [`encoding_type(Option<EncodingType>)`](crate::operation::list_object_versions::ListObjectVersionsOutput::encoding_type): <p> Encoding type used by Amazon S3 to encode object key names in the XML response.</p>  <p>If you specify encoding-type request parameter, Amazon S3 includes this element in the response, and returns encoded key name values in the following response elements:</p>  <p> <code>KeyMarker, NextKeyMarker, Prefix, Key</code>, and <code>Delimiter</code>.</p>
    /// - On failure, responds with [`SdkError<ListObjectVersionsError>`](crate::operation::list_object_versions::ListObjectVersionsError)
    pub fn list_object_versions(
        &self,
    ) -> crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder {
        crate::operation::list_object_versions::builders::ListObjectVersionsFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
