// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutBucketAcl`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`acl(BucketCannedAcl)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::acl) / [`set_acl(Option<BucketCannedAcl>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_acl): <p>The canned ACL to apply to the bucket.</p>
    ///   - [`access_control_policy(AccessControlPolicy)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::access_control_policy) / [`set_access_control_policy(Option<AccessControlPolicy>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_access_control_policy): <p>Contains the elements that set the ACL permissions for an object per grantee.</p>
    ///   - [`bucket(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::bucket) / [`set_bucket(Option<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_bucket): <p>The bucket to which to apply the ACL.</p>
    ///   - [`content_md5(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::content_md5) / [`set_content_md5(Option<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_content_md5): <p>The base64-encoded 128-bit MD5 digest of the data. This header must be used as a message integrity check to verify that the request body was not corrupted in transit. For more information, go to <a href="http://www.ietf.org/rfc/rfc1864.txt">RFC 1864.</a> </p>  <p>For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.</p>
    ///   - [`checksum_algorithm(ChecksumAlgorithm)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::checksum_algorithm) / [`set_checksum_algorithm(Option<ChecksumAlgorithm>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_checksum_algorithm): <p>Indicates the algorithm used to create the checksum for the object when using the SDK. This header will not provide any additional functionality if not using the SDK. When sending this header, there must be a corresponding <code>x-amz-checksum</code> or <code>x-amz-trailer</code> header sent. Otherwise, Amazon S3 fails the request with the HTTP status code <code>400 Bad Request</code>. For more information, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/checking-object-integrity.html">Checking object integrity</a> in the <i>Amazon S3 User Guide</i>.</p>  <p>If you provide an individual checksum, Amazon S3 ignores any provided <code>ChecksumAlgorithm</code> parameter.</p>
    ///   - [`grant_full_control(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::grant_full_control) / [`set_grant_full_control(Option<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_grant_full_control): <p>Allows grantee the read, write, read ACP, and write ACP permissions on the bucket.</p>
    ///   - [`grant_read(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::grant_read) / [`set_grant_read(Option<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_grant_read): <p>Allows grantee to list the objects in the bucket.</p>
    ///   - [`grant_read_acp(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::grant_read_acp) / [`set_grant_read_acp(Option<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_grant_read_acp): <p>Allows grantee to read the bucket ACL.</p>
    ///   - [`grant_write(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::grant_write) / [`set_grant_write(Option<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_grant_write): <p>Allows grantee to create new objects in the bucket.</p>  <p>For the bucket and object owners of existing objects, also allows deletions and overwrites of those objects.</p>
    ///   - [`grant_write_acp(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::grant_write_acp) / [`set_grant_write_acp(Option<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_grant_write_acp): <p>Allows grantee to write the ACL for the applicable bucket.</p>
    ///   - [`expected_bucket_owner(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::expected_bucket_owner) / [`set_expected_bucket_owner(Option<String>)`](crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::set_expected_bucket_owner): <p>The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code <code>403 Forbidden</code> (access denied).</p>
    /// - On success, responds with [`PutBucketAclOutput`](crate::operation::put_bucket_acl::PutBucketAclOutput)
    /// - On failure, responds with [`SdkError<PutBucketAclError>`](crate::operation::put_bucket_acl::PutBucketAclError)
    pub fn put_bucket_acl(
        &self,
    ) -> crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder {
        crate::operation::put_bucket_acl::builders::PutBucketAclFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
