// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutBucketLogging`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`bucket(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::bucket) / [`set_bucket(Option<String>)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::set_bucket): <p>The name of the bucket for which to set the logging parameters.</p>
    ///   - [`bucket_logging_status(BucketLoggingStatus)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::bucket_logging_status) / [`set_bucket_logging_status(Option<BucketLoggingStatus>)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::set_bucket_logging_status): <p>Container for logging status information.</p>
    ///   - [`content_md5(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::content_md5) / [`set_content_md5(Option<String>)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::set_content_md5): <p>The MD5 hash of the <code>PutBucketLogging</code> request body.</p>  <p>For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.</p>
    ///   - [`checksum_algorithm(ChecksumAlgorithm)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::checksum_algorithm) / [`set_checksum_algorithm(Option<ChecksumAlgorithm>)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::set_checksum_algorithm): <p>Indicates the algorithm used to create the checksum for the object when using the SDK. This header will not provide any additional functionality if not using the SDK. When sending this header, there must be a corresponding <code>x-amz-checksum</code> or <code>x-amz-trailer</code> header sent. Otherwise, Amazon S3 fails the request with the HTTP status code <code>400 Bad Request</code>. For more information, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/checking-object-integrity.html">Checking object integrity</a> in the <i>Amazon S3 User Guide</i>.</p>  <p>If you provide an individual checksum, Amazon S3 ignores any provided <code>ChecksumAlgorithm</code> parameter.</p>
    ///   - [`expected_bucket_owner(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::expected_bucket_owner) / [`set_expected_bucket_owner(Option<String>)`](crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::set_expected_bucket_owner): <p>The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code <code>403 Forbidden</code> (access denied).</p>
    /// - On success, responds with [`PutBucketLoggingOutput`](crate::operation::put_bucket_logging::PutBucketLoggingOutput)
    /// - On failure, responds with [`SdkError<PutBucketLoggingError>`](crate::operation::put_bucket_logging::PutBucketLoggingError)
    pub fn put_bucket_logging(
        &self,
    ) -> crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder {
        crate::operation::put_bucket_logging::builders::PutBucketLoggingFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
