// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutBucketOwnershipControls`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`bucket(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::bucket) / [`set_bucket(Option<String>)`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::set_bucket): <p>The name of the Amazon S3 bucket whose <code>OwnershipControls</code> you want to set.</p>
    ///   - [`content_md5(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::content_md5) / [`set_content_md5(Option<String>)`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::set_content_md5): <p>The MD5 hash of the <code>OwnershipControls</code> request body. </p>  <p>For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.</p>
    ///   - [`expected_bucket_owner(impl ::std::convert::Into<String>)`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::expected_bucket_owner) / [`set_expected_bucket_owner(Option<String>)`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::set_expected_bucket_owner): <p>The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code <code>403 Forbidden</code> (access denied).</p>
    ///   - [`ownership_controls(OwnershipControls)`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::ownership_controls) / [`set_ownership_controls(Option<OwnershipControls>)`](crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::set_ownership_controls): <p>The <code>OwnershipControls</code> (BucketOwnerEnforced, BucketOwnerPreferred, or ObjectWriter) that you want to apply to this Amazon S3 bucket.</p>
    /// - On success, responds with [`PutBucketOwnershipControlsOutput`](crate::operation::put_bucket_ownership_controls::PutBucketOwnershipControlsOutput)
    /// - On failure, responds with [`SdkError<PutBucketOwnershipControlsError>`](crate::operation::put_bucket_ownership_controls::PutBucketOwnershipControlsError)
    pub fn put_bucket_ownership_controls(&self) -> crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder{
        crate::operation::put_bucket_ownership_controls::builders::PutBucketOwnershipControlsFluentBuilder::new(self.handle.clone())
    }
}
