// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutObjectLegalHold`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`bucket(impl ::std::convert::Into<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::bucket) / [`set_bucket(Option<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::set_bucket): <p>The bucket name containing the object that you want to place a legal hold on. </p>  <p>When using this action with an access point, you must direct requests to the access point hostname. The access point hostname takes the form <i>AccessPointName</i>-<i>AccountId</i>.s3-accesspoint.<i>Region</i>.amazonaws.com. When using this action with an access point through the Amazon Web Services SDKs, you provide the access point ARN in place of the bucket name. For more information about access point ARNs, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/using-access-points.html">Using access points</a> in the <i>Amazon S3 User Guide</i>.</p>
    ///   - [`key(impl ::std::convert::Into<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::key) / [`set_key(Option<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::set_key): <p>The key name for the object that you want to place a legal hold on.</p>
    ///   - [`legal_hold(ObjectLockLegalHold)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::legal_hold) / [`set_legal_hold(Option<ObjectLockLegalHold>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::set_legal_hold): <p>Container element for the legal hold configuration you want to apply to the specified object.</p>
    ///   - [`request_payer(RequestPayer)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::request_payer) / [`set_request_payer(Option<RequestPayer>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::set_request_payer): <p>Confirms that the requester knows that they will be charged for the request. Bucket owners need not specify this parameter in their requests. For information about downloading objects from Requester Pays buckets, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/dev/ObjectsinRequesterPaysBuckets.html">Downloading Objects in Requester Pays Buckets</a> in the <i>Amazon S3 User Guide</i>.</p>
    ///   - [`version_id(impl ::std::convert::Into<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::version_id) / [`set_version_id(Option<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::set_version_id): <p>The version ID of the object that you want to place a legal hold on.</p>
    ///   - [`content_md5(impl ::std::convert::Into<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::content_md5) / [`set_content_md5(Option<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::set_content_md5): <p>The MD5 hash for the request body.</p>  <p>For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.</p>
    ///   - [`checksum_algorithm(ChecksumAlgorithm)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::checksum_algorithm) / [`set_checksum_algorithm(Option<ChecksumAlgorithm>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::set_checksum_algorithm): <p>Indicates the algorithm used to create the checksum for the object when using the SDK. This header will not provide any additional functionality if not using the SDK. When sending this header, there must be a corresponding <code>x-amz-checksum</code> or <code>x-amz-trailer</code> header sent. Otherwise, Amazon S3 fails the request with the HTTP status code <code>400 Bad Request</code>. For more information, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/checking-object-integrity.html">Checking object integrity</a> in the <i>Amazon S3 User Guide</i>.</p>  <p>If you provide an individual checksum, Amazon S3 ignores any provided <code>ChecksumAlgorithm</code> parameter.</p>
    ///   - [`expected_bucket_owner(impl ::std::convert::Into<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::expected_bucket_owner) / [`set_expected_bucket_owner(Option<String>)`](crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::set_expected_bucket_owner): <p>The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code <code>403 Forbidden</code> (access denied).</p>
    /// - On success, responds with [`PutObjectLegalHoldOutput`](crate::operation::put_object_legal_hold::PutObjectLegalHoldOutput) with field(s):
    ///   - [`request_charged(Option<RequestCharged>)`](crate::operation::put_object_legal_hold::PutObjectLegalHoldOutput::request_charged): <p>If present, indicates that the requester was successfully charged for the request.</p>
    /// - On failure, responds with [`SdkError<PutObjectLegalHoldError>`](crate::operation::put_object_legal_hold::PutObjectLegalHoldError)
    pub fn put_object_legal_hold(
        &self,
    ) -> crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder {
        crate::operation::put_object_legal_hold::builders::PutObjectLegalHoldFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
