// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutObjectLockConfiguration`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`bucket(impl ::std::convert::Into<String>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::bucket) / [`set_bucket(Option<String>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::set_bucket): <p>The bucket whose Object Lock configuration you want to create or replace.</p>
    ///   - [`object_lock_configuration(ObjectLockConfiguration)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::object_lock_configuration) / [`set_object_lock_configuration(Option<ObjectLockConfiguration>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::set_object_lock_configuration): <p>The Object Lock configuration that you want to apply to the specified bucket.</p>
    ///   - [`request_payer(RequestPayer)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::request_payer) / [`set_request_payer(Option<RequestPayer>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::set_request_payer): <p>Confirms that the requester knows that they will be charged for the request. Bucket owners need not specify this parameter in their requests. For information about downloading objects from Requester Pays buckets, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/dev/ObjectsinRequesterPaysBuckets.html">Downloading Objects in Requester Pays Buckets</a> in the <i>Amazon S3 User Guide</i>.</p>
    ///   - [`token(impl ::std::convert::Into<String>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::token) / [`set_token(Option<String>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::set_token): <p>A token to allow Object Lock to be enabled for an existing bucket.</p>
    ///   - [`content_md5(impl ::std::convert::Into<String>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::content_md5) / [`set_content_md5(Option<String>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::set_content_md5): <p>The MD5 hash for the request body.</p>  <p>For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.</p>
    ///   - [`checksum_algorithm(ChecksumAlgorithm)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::checksum_algorithm) / [`set_checksum_algorithm(Option<ChecksumAlgorithm>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::set_checksum_algorithm): <p>Indicates the algorithm used to create the checksum for the object when using the SDK. This header will not provide any additional functionality if not using the SDK. When sending this header, there must be a corresponding <code>x-amz-checksum</code> or <code>x-amz-trailer</code> header sent. Otherwise, Amazon S3 fails the request with the HTTP status code <code>400 Bad Request</code>. For more information, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/checking-object-integrity.html">Checking object integrity</a> in the <i>Amazon S3 User Guide</i>.</p>  <p>If you provide an individual checksum, Amazon S3 ignores any provided <code>ChecksumAlgorithm</code> parameter.</p>
    ///   - [`expected_bucket_owner(impl ::std::convert::Into<String>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::expected_bucket_owner) / [`set_expected_bucket_owner(Option<String>)`](crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::set_expected_bucket_owner): <p>The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code <code>403 Forbidden</code> (access denied).</p>
    /// - On success, responds with [`PutObjectLockConfigurationOutput`](crate::operation::put_object_lock_configuration::PutObjectLockConfigurationOutput) with field(s):
    ///   - [`request_charged(Option<RequestCharged>)`](crate::operation::put_object_lock_configuration::PutObjectLockConfigurationOutput::request_charged): <p>If present, indicates that the requester was successfully charged for the request.</p>
    /// - On failure, responds with [`SdkError<PutObjectLockConfigurationError>`](crate::operation::put_object_lock_configuration::PutObjectLockConfigurationError)
    pub fn put_object_lock_configuration(&self) -> crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder{
        crate::operation::put_object_lock_configuration::builders::PutObjectLockConfigurationFluentBuilder::new(self.handle.clone())
    }
}
