// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`PutObjectTagging`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`bucket(impl ::std::convert::Into<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::bucket) / [`set_bucket(Option<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::set_bucket): <p>The bucket name containing the object. </p>  <p>When using this action with an access point, you must direct requests to the access point hostname. The access point hostname takes the form <i>AccessPointName</i>-<i>AccountId</i>.s3-accesspoint.<i>Region</i>.amazonaws.com. When using this action with an access point through the Amazon Web Services SDKs, you provide the access point ARN in place of the bucket name. For more information about access point ARNs, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/using-access-points.html">Using access points</a> in the <i>Amazon S3 User Guide</i>.</p>  <p>When you use this action with Amazon S3 on Outposts, you must direct requests to the S3 on Outposts hostname. The S3 on Outposts hostname takes the form <code> <i>AccessPointName</i>-<i>AccountId</i>.<i>outpostID</i>.s3-outposts.<i>Region</i>.amazonaws.com</code>. When you use this action with S3 on Outposts through the Amazon Web Services SDKs, you provide the Outposts access point ARN in place of the bucket name. For more information about S3 on Outposts ARNs, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/S3onOutposts.html">What is S3 on Outposts</a> in the <i>Amazon S3 User Guide</i>.</p>
    ///   - [`key(impl ::std::convert::Into<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::key) / [`set_key(Option<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::set_key): <p>Name of the object key.</p>
    ///   - [`version_id(impl ::std::convert::Into<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::version_id) / [`set_version_id(Option<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::set_version_id): <p>The versionId of the object that the tag-set will be added to.</p>
    ///   - [`content_md5(impl ::std::convert::Into<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::content_md5) / [`set_content_md5(Option<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::set_content_md5): <p>The MD5 hash for the request body.</p>  <p>For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.</p>
    ///   - [`checksum_algorithm(ChecksumAlgorithm)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::checksum_algorithm) / [`set_checksum_algorithm(Option<ChecksumAlgorithm>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::set_checksum_algorithm): <p>Indicates the algorithm used to create the checksum for the object when using the SDK. This header will not provide any additional functionality if not using the SDK. When sending this header, there must be a corresponding <code>x-amz-checksum</code> or <code>x-amz-trailer</code> header sent. Otherwise, Amazon S3 fails the request with the HTTP status code <code>400 Bad Request</code>. For more information, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/userguide/checking-object-integrity.html">Checking object integrity</a> in the <i>Amazon S3 User Guide</i>.</p>  <p>If you provide an individual checksum, Amazon S3 ignores any provided <code>ChecksumAlgorithm</code> parameter.</p>
    ///   - [`tagging(Tagging)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::tagging) / [`set_tagging(Option<Tagging>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::set_tagging): <p>Container for the <code>TagSet</code> and <code>Tag</code> elements</p>
    ///   - [`expected_bucket_owner(impl ::std::convert::Into<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::expected_bucket_owner) / [`set_expected_bucket_owner(Option<String>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::set_expected_bucket_owner): <p>The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code <code>403 Forbidden</code> (access denied).</p>
    ///   - [`request_payer(RequestPayer)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::request_payer) / [`set_request_payer(Option<RequestPayer>)`](crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::set_request_payer): <p>Confirms that the requester knows that they will be charged for the request. Bucket owners need not specify this parameter in their requests. For information about downloading objects from Requester Pays buckets, see <a href="https://docs.aws.amazon.com/AmazonS3/latest/dev/ObjectsinRequesterPaysBuckets.html">Downloading Objects in Requester Pays Buckets</a> in the <i>Amazon S3 User Guide</i>.</p>
    /// - On success, responds with [`PutObjectTaggingOutput`](crate::operation::put_object_tagging::PutObjectTaggingOutput) with field(s):
    ///   - [`version_id(Option<String>)`](crate::operation::put_object_tagging::PutObjectTaggingOutput::version_id): <p>The versionId of the object the tag-set was added to.</p>
    /// - On failure, responds with [`SdkError<PutObjectTaggingError>`](crate::operation::put_object_tagging::PutObjectTaggingError)
    pub fn put_object_tagging(
        &self,
    ) -> crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder {
        crate::operation::put_object_tagging::builders::PutObjectTaggingFluentBuilder::new(
            self.handle.clone(),
        )
    }
}
