// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct ListBucketMetricsConfigurationsOutput {
    /// <p>Indicates whether the returned list of metrics configurations is complete. A value of true indicates that the list is not complete and the NextContinuationToken will be provided for a subsequent request.</p>
    #[doc(hidden)]
    pub is_truncated: bool,
    /// <p>The marker that is used as a starting point for this metrics configuration list response. This value is present if it was sent in the request.</p>
    #[doc(hidden)]
    pub continuation_token: ::std::option::Option<::std::string::String>,
    /// <p>The marker used to continue a metrics configuration listing that has been truncated. Use the <code>NextContinuationToken</code> from a previously truncated list response to continue the listing. The continuation token is an opaque value that Amazon S3 understands.</p>
    #[doc(hidden)]
    pub next_continuation_token: ::std::option::Option<::std::string::String>,
    /// <p>The list of metrics configurations for a bucket.</p>
    #[doc(hidden)]
    pub metrics_configuration_list:
        ::std::option::Option<::std::vec::Vec<crate::types::MetricsConfiguration>>,
    _extended_request_id: Option<String>,
    _request_id: Option<String>,
}
impl ListBucketMetricsConfigurationsOutput {
    /// <p>Indicates whether the returned list of metrics configurations is complete. A value of true indicates that the list is not complete and the NextContinuationToken will be provided for a subsequent request.</p>
    pub fn is_truncated(&self) -> bool {
        self.is_truncated
    }
    /// <p>The marker that is used as a starting point for this metrics configuration list response. This value is present if it was sent in the request.</p>
    pub fn continuation_token(&self) -> ::std::option::Option<&str> {
        self.continuation_token.as_deref()
    }
    /// <p>The marker used to continue a metrics configuration listing that has been truncated. Use the <code>NextContinuationToken</code> from a previously truncated list response to continue the listing. The continuation token is an opaque value that Amazon S3 understands.</p>
    pub fn next_continuation_token(&self) -> ::std::option::Option<&str> {
        self.next_continuation_token.as_deref()
    }
    /// <p>The list of metrics configurations for a bucket.</p>
    pub fn metrics_configuration_list(
        &self,
    ) -> ::std::option::Option<&[crate::types::MetricsConfiguration]> {
        self.metrics_configuration_list.as_deref()
    }
}
impl crate::s3_request_id::RequestIdExt for ListBucketMetricsConfigurationsOutput {
    fn extended_request_id(&self) -> Option<&str> {
        self._extended_request_id.as_deref()
    }
}
impl ::aws_http::request_id::RequestId for ListBucketMetricsConfigurationsOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl ListBucketMetricsConfigurationsOutput {
    /// Creates a new builder-style object to manufacture [`ListBucketMetricsConfigurationsOutput`](crate::operation::list_bucket_metrics_configurations::ListBucketMetricsConfigurationsOutput).
    pub fn builder() -> crate::operation::list_bucket_metrics_configurations::builders::ListBucketMetricsConfigurationsOutputBuilder{
        crate::operation::list_bucket_metrics_configurations::builders::ListBucketMetricsConfigurationsOutputBuilder::default()
    }
}

/// A builder for [`ListBucketMetricsConfigurationsOutput`](crate::operation::list_bucket_metrics_configurations::ListBucketMetricsConfigurationsOutput).
#[non_exhaustive]
#[derive(
    ::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug,
)]
pub struct ListBucketMetricsConfigurationsOutputBuilder {
    pub(crate) is_truncated: ::std::option::Option<bool>,
    pub(crate) continuation_token: ::std::option::Option<::std::string::String>,
    pub(crate) next_continuation_token: ::std::option::Option<::std::string::String>,
    pub(crate) metrics_configuration_list:
        ::std::option::Option<::std::vec::Vec<crate::types::MetricsConfiguration>>,
    _extended_request_id: Option<String>,
    _request_id: Option<String>,
}
impl ListBucketMetricsConfigurationsOutputBuilder {
    /// <p>Indicates whether the returned list of metrics configurations is complete. A value of true indicates that the list is not complete and the NextContinuationToken will be provided for a subsequent request.</p>
    pub fn is_truncated(mut self, input: bool) -> Self {
        self.is_truncated = ::std::option::Option::Some(input);
        self
    }
    /// <p>Indicates whether the returned list of metrics configurations is complete. A value of true indicates that the list is not complete and the NextContinuationToken will be provided for a subsequent request.</p>
    pub fn set_is_truncated(mut self, input: ::std::option::Option<bool>) -> Self {
        self.is_truncated = input;
        self
    }
    /// <p>The marker that is used as a starting point for this metrics configuration list response. This value is present if it was sent in the request.</p>
    pub fn continuation_token(
        mut self,
        input: impl ::std::convert::Into<::std::string::String>,
    ) -> Self {
        self.continuation_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The marker that is used as a starting point for this metrics configuration list response. This value is present if it was sent in the request.</p>
    pub fn set_continuation_token(
        mut self,
        input: ::std::option::Option<::std::string::String>,
    ) -> Self {
        self.continuation_token = input;
        self
    }
    /// <p>The marker used to continue a metrics configuration listing that has been truncated. Use the <code>NextContinuationToken</code> from a previously truncated list response to continue the listing. The continuation token is an opaque value that Amazon S3 understands.</p>
    pub fn next_continuation_token(
        mut self,
        input: impl ::std::convert::Into<::std::string::String>,
    ) -> Self {
        self.next_continuation_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The marker used to continue a metrics configuration listing that has been truncated. Use the <code>NextContinuationToken</code> from a previously truncated list response to continue the listing. The continuation token is an opaque value that Amazon S3 understands.</p>
    pub fn set_next_continuation_token(
        mut self,
        input: ::std::option::Option<::std::string::String>,
    ) -> Self {
        self.next_continuation_token = input;
        self
    }
    /// Appends an item to `metrics_configuration_list`.
    ///
    /// To override the contents of this collection use [`set_metrics_configuration_list`](Self::set_metrics_configuration_list).
    ///
    /// <p>The list of metrics configurations for a bucket.</p>
    pub fn metrics_configuration_list(mut self, input: crate::types::MetricsConfiguration) -> Self {
        let mut v = self.metrics_configuration_list.unwrap_or_default();
        v.push(input);
        self.metrics_configuration_list = ::std::option::Option::Some(v);
        self
    }
    /// <p>The list of metrics configurations for a bucket.</p>
    pub fn set_metrics_configuration_list(
        mut self,
        input: ::std::option::Option<::std::vec::Vec<crate::types::MetricsConfiguration>>,
    ) -> Self {
        self.metrics_configuration_list = input;
        self
    }
    pub(crate) fn _extended_request_id(mut self, extended_request_id: impl Into<String>) -> Self {
        self._extended_request_id = Some(extended_request_id.into());
        self
    }

    pub(crate) fn _set_extended_request_id(
        &mut self,
        extended_request_id: Option<String>,
    ) -> &mut Self {
        self._extended_request_id = extended_request_id;
        self
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`ListBucketMetricsConfigurationsOutput`](crate::operation::list_bucket_metrics_configurations::ListBucketMetricsConfigurationsOutput).
    pub fn build(
        self,
    ) -> crate::operation::list_bucket_metrics_configurations::ListBucketMetricsConfigurationsOutput
    {
        crate::operation::list_bucket_metrics_configurations::ListBucketMetricsConfigurationsOutput {
            is_truncated: self.is_truncated
                .unwrap_or_default()
            ,
            continuation_token: self.continuation_token
            ,
            next_continuation_token: self.next_continuation_token
            ,
            metrics_configuration_list: self.metrics_configuration_list
            ,
            _extended_request_id: self._extended_request_id,
            _request_id: self._request_id,
        }
    }
}
