// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.

/// <p> A container specifying S3 Replication Time Control (S3 RTC) related information, including whether S3 RTC is enabled and the time when all objects and operations on objects must be replicated. Must be specified together with a <code>Metrics</code> block. </p>
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct ReplicationTime {
    /// <p> Specifies whether the replication time is enabled. </p>
    #[doc(hidden)]
    pub status: ::std::option::Option<crate::types::ReplicationTimeStatus>,
    /// <p> A container specifying the time by which replication should be complete for all objects and operations on objects. </p>
    #[doc(hidden)]
    pub time: ::std::option::Option<crate::types::ReplicationTimeValue>,
}
impl ReplicationTime {
    /// <p> Specifies whether the replication time is enabled. </p>
    pub fn status(&self) -> ::std::option::Option<&crate::types::ReplicationTimeStatus> {
        self.status.as_ref()
    }
    /// <p> A container specifying the time by which replication should be complete for all objects and operations on objects. </p>
    pub fn time(&self) -> ::std::option::Option<&crate::types::ReplicationTimeValue> {
        self.time.as_ref()
    }
}
impl ReplicationTime {
    /// Creates a new builder-style object to manufacture [`ReplicationTime`](crate::types::ReplicationTime).
    pub fn builder() -> crate::types::builders::ReplicationTimeBuilder {
        crate::types::builders::ReplicationTimeBuilder::default()
    }
}

/// A builder for [`ReplicationTime`](crate::types::ReplicationTime).
#[non_exhaustive]
#[derive(
    ::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug,
)]
pub struct ReplicationTimeBuilder {
    pub(crate) status: ::std::option::Option<crate::types::ReplicationTimeStatus>,
    pub(crate) time: ::std::option::Option<crate::types::ReplicationTimeValue>,
}
impl ReplicationTimeBuilder {
    /// <p> Specifies whether the replication time is enabled. </p>
    pub fn status(mut self, input: crate::types::ReplicationTimeStatus) -> Self {
        self.status = ::std::option::Option::Some(input);
        self
    }
    /// <p> Specifies whether the replication time is enabled. </p>
    pub fn set_status(
        mut self,
        input: ::std::option::Option<crate::types::ReplicationTimeStatus>,
    ) -> Self {
        self.status = input;
        self
    }
    /// <p> A container specifying the time by which replication should be complete for all objects and operations on objects. </p>
    pub fn time(mut self, input: crate::types::ReplicationTimeValue) -> Self {
        self.time = ::std::option::Option::Some(input);
        self
    }
    /// <p> A container specifying the time by which replication should be complete for all objects and operations on objects. </p>
    pub fn set_time(
        mut self,
        input: ::std::option::Option<crate::types::ReplicationTimeValue>,
    ) -> Self {
        self.time = input;
        self
    }
    /// Consumes the builder and constructs a [`ReplicationTime`](crate::types::ReplicationTime).
    pub fn build(self) -> crate::types::ReplicationTime {
        crate::types::ReplicationTime {
            status: self.status,
            time: self.time,
        }
    }
}
